    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------------------
    028     * StandardXYToolTipGenerator.java
    029     * -------------------------------
    030     * (C) Copyright 2004, 2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: StandardXYToolTipGenerator.java,v 1.3.2.1 2005/10/25 20:49:02 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 12-May-2004 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.chart.labels;
    044
    045    import java.io.Serializable;
    046    import java.text.DateFormat;
    047    import java.text.NumberFormat;
    048
    049    import org.jfree.data.xy.XYDataset;
    050    import org.jfree.util.PublicCloneable;
    051
    052    /**
    053     * A standard tool tip generator for use with an
    054     * {@link org.jfree.chart.renderer.xy.XYItemRenderer}.
    055     */
    056    public class StandardXYToolTipGenerator extends AbstractXYItemLabelGenerator
    057                                            implements XYToolTipGenerator,
    058                                                       Cloneable,
    059                                                       PublicCloneable,
    060                                                       Serializable {
    061
    062        /** For serialization. */
    063        private static final long serialVersionUID = -3564164459039540784L;
    064
    065        /** The default tooltip format. */
    066        public static final String DEFAULT_TOOL_TIP_FORMAT = "{0}: ({1}, {2})";
    067
    068        /**
    069         * Returns a tool tip generator that formats the x-values as dates and the
    070         * y-values as numbers.
    071         *
    072         * @return A tool tip generator (never <code>null</code>).
    073         */
    074        public static StandardXYToolTipGenerator getTimeSeriesInstance() {
    075            return new StandardXYToolTipGenerator(
    076                DEFAULT_TOOL_TIP_FORMAT, DateFormat.getInstance(),
    077                NumberFormat.getInstance()
    078            );
    079        }
    080
    081        /**
    082         * Creates a tool tip generator using default number formatters.
    083         */
    084        public StandardXYToolTipGenerator() {
    085            this(
    086                DEFAULT_TOOL_TIP_FORMAT,
    087                NumberFormat.getNumberInstance(), NumberFormat.getNumberInstance()
    088            );
    089        }
    090
    091        /**
    092         * Creates a tool tip generator using the specified number formatters.
    093         *
    094         * @param formatString  the item label format string (<code>null</code> not
    095         *                      permitted).
    096         * @param xFormat  the format object for the x values (<code>null</code>
    097         *                 not permitted).
    098         * @param yFormat  the format object for the y values (<code>null</code>
    099         *                 not permitted).
    100         */
    101        public StandardXYToolTipGenerator(String formatString,
    102                                          NumberFormat xFormat,
    103                                          NumberFormat yFormat) {
    104
    105            super(formatString, xFormat, yFormat);
    106
    107        }
    108
    109        /**
    110         * Creates a tool tip generator using the specified number formatters.
    111         *
    112         * @param formatString  the label format string (<code>null</code> not
    113         *                      permitted).
    114         * @param xFormat  the format object for the x values (<code>null</code>
    115         *                 not permitted).
    116         * @param yFormat  the format object for the y values (<code>null</code>
    117         *                 not permitted).
    118         */
    119        public StandardXYToolTipGenerator(String formatString,
    120                                          DateFormat xFormat,
    121                                          NumberFormat yFormat) {
    122
    123            super(formatString, xFormat, yFormat);
    124
    125        }
    126
    127        /**
    128         * Creates a tool tip generator using the specified date formatters.
    129         *
    130         * @param formatString  the label format string (<code>null</code> not
    131         *                      permitted).
    132         * @param xFormat  the format object for the x values (<code>null</code>
    133         *                 not permitted).
    134         * @param yFormat  the format object for the y values (<code>null</code>
    135         *                 not permitted).
    136         */
    137        public StandardXYToolTipGenerator(String formatString,
    138                                          DateFormat xFormat,
    139                                          DateFormat yFormat) {
    140
    141            super(formatString, xFormat, yFormat);
    142
    143        }
    144
    145        /**
    146         * Generates the tool tip text for an item in a dataset.
    147         *
    148         * @param dataset  the dataset (<code>null</code> not permitted).
    149         * @param series  the series index (zero-based).
    150         * @param item  the item index (zero-based).
    151         *
    152         * @return The tooltip text (possibly <code>null</code>).
    153         */
    154        public String generateToolTip(XYDataset dataset, int series, int item) {
    155            return generateLabelString(dataset, series, item);
    156        }
    157
    158        /**
    159         * Tests this object for equality with an arbitrary object.
    160         *
    161         * @param obj  the other object (<code>null</code> permitted).
    162         *
    163         * @return A boolean.
    164         */
    165        public boolean equals(Object obj) {
    166            if (obj == this) {
    167                return true;
    168            }
    169            if (obj instanceof StandardXYToolTipGenerator) {
    170                return super.equals(obj);
    171            }
    172            return false;
    173        }
    174
    175        /**
    176         * Returns an independent copy of the generator.
    177         *
    178         * @return A clone.
    179         *
    180         * @throws CloneNotSupportedException if cloning is not supported.
    181         */
    182        public Object clone() throws CloneNotSupportedException {
    183            return super.clone();
    184        }
    185
    186    }